// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.quadrige2.core.dao.referential;

import fr.ifremer.quadrige2.core.dao.data.measurement.TaxonMeasurement;
import fr.ifremer.quadrige2.core.dao.data.survey.MeasuredProfile;
import fr.ifremer.quadrige2.core.dao.data.survey.Video;
import fr.ifremer.quadrige2.core.dao.sandre.SandreQualityLevelExp;
import fr.ifremer.quadrige2.core.dao.sandre.SandreQualityLevelImp;
import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.HashSet;

/**
 * Liste des niveaux de qualification.
 */
// HibernateEntity.vsl annotations merge-point
public abstract class QualityFlag
    implements Serializable, Comparable<QualityFlag>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 1683091495343672195L;

    // Generate 4 attributes
    private String qualFlagCd;

    /**
     * Code identifiant le niveau de qualification (0,1,2, 3,4).
     * @return this.qualFlagCd String
     */
    public String getQualFlagCd()
    {
        return this.qualFlagCd;
    }

    /**
     * Code identifiant le niveau de qualification (0,1,2, 3,4).
     * @param qualFlagCdIn String
     */
    public void setQualFlagCd(String qualFlagCdIn)
    {
        this.qualFlagCd = qualFlagCdIn;
    }

    private String qualFlagNm;

    /**
     * Libellé du niveau de qualification
     * @return this.qualFlagNm String
     */
    public String getQualFlagNm()
    {
        return this.qualFlagNm;
    }

    /**
     * Libellé du niveau de qualification
     * @param qualFlagNmIn String
     */
    public void setQualFlagNm(String qualFlagNmIn)
    {
        this.qualFlagNm = qualFlagNmIn;
    }

    private String qualFlagDc;

    /**
     * Description optionnelle de la qualification
     * @return this.qualFlagDc String
     */
    public String getQualFlagDc()
    {
        return this.qualFlagDc;
    }

    /**
     * Description optionnelle de la qualification
     * @param qualFlagDcIn String
     */
    public void setQualFlagDc(String qualFlagDcIn)
    {
        this.qualFlagDc = qualFlagDcIn;
    }

    private Timestamp updateDt;

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @return this.updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @param updateDtIn Timestamp
     */
    public void setUpdateDt(Timestamp updateDtIn)
    {
        this.updateDt = updateDtIn;
    }

    // Generate 17 associations
    private Collection<TaxonMeasurement> taxonMeasurements = new HashSet<TaxonMeasurement>();

    /**
     * Résultat de mesure faisant l'objet d'une mesure unique pour un taxon, ou un regroupement de
     * taxon
     * particulier.
     * @return this.taxonMeasurements Collection<TaxonMeasurement>
     */
    public Collection<TaxonMeasurement> getTaxonMeasurements()
    {
        return this.taxonMeasurements;
    }

    /**
     * Résultat de mesure faisant l'objet d'une mesure unique pour un taxon, ou un regroupement de
     * taxon
     * particulier.
     * @param taxonMeasurementsIn Collection<TaxonMeasurement>
     */
    public void setTaxonMeasurements(Collection<TaxonMeasurement> taxonMeasurementsIn)
    {
        this.taxonMeasurements = taxonMeasurementsIn;
    }

    /**
     * Résultat de mesure faisant l'objet d'une mesure unique pour un taxon, ou un regroupement de
     * taxon
     * particulier.
     * @param elementToAdd TaxonMeasurement
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addTaxonMeasurements(TaxonMeasurement elementToAdd)
    {
        return this.taxonMeasurements.add(elementToAdd);
    }

    /**
     * Résultat de mesure faisant l'objet d'une mesure unique pour un taxon, ou un regroupement de
     * taxon
     * particulier.
     * @param elementToRemove TaxonMeasurement
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeTaxonMeasurements(TaxonMeasurement elementToRemove)
    {
        return this.taxonMeasurements.remove(elementToRemove);
    }

    private Collection<SandreQualityLevelExp> sandreQualityLevelExpIds = new HashSet<SandreQualityLevelExp>();

    /**
     * Niveau de qualité sandre pour les exports de données
     * @return this.sandreQualityLevelExpIds Collection<SandreQualityLevelExp>
     */
    public Collection<SandreQualityLevelExp> getSandreQualityLevelExpIds()
    {
        return this.sandreQualityLevelExpIds;
    }

    /**
     * Niveau de qualité sandre pour les exports de données
     * @param sandreQualityLevelExpIdsIn Collection<SandreQualityLevelExp>
     */
    public void setSandreQualityLevelExpIds(Collection<SandreQualityLevelExp> sandreQualityLevelExpIdsIn)
    {
        this.sandreQualityLevelExpIds = sandreQualityLevelExpIdsIn;
    }

    /**
     * Niveau de qualité sandre pour les exports de données
     * @param elementToAdd SandreQualityLevelExp
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addSandreQualityLevelExpIds(SandreQualityLevelExp elementToAdd)
    {
        return this.sandreQualityLevelExpIds.add(elementToAdd);
    }

    /**
     * Niveau de qualité sandre pour les exports de données
     * @param elementToRemove SandreQualityLevelExp
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeSandreQualityLevelExpIds(SandreQualityLevelExp elementToRemove)
    {
        return this.sandreQualityLevelExpIds.remove(elementToRemove);
    }

    private Collection<Video> videoIds = new HashSet<Video>();

    /**
     * Liste des vidéos sur un passage.
     * @return this.videoIds Collection<Video>
     */
    public Collection<Video> getVideoIds()
    {
        return this.videoIds;
    }

    /**
     * Liste des vidéos sur un passage.
     * @param videoIdsIn Collection<Video>
     */
    public void setVideoIds(Collection<Video> videoIdsIn)
    {
        this.videoIds = videoIdsIn;
    }

    /**
     * Liste des vidéos sur un passage.
     * @param elementToAdd Video
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addVideoIds(Video elementToAdd)
    {
        return this.videoIds.add(elementToAdd);
    }

    /**
     * Liste des vidéos sur un passage.
     * @param elementToRemove Video
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeVideoIds(Video elementToRemove)
    {
        return this.videoIds.remove(elementToRemove);
    }

    private Status status;

    /**
     * Liste des états possibles d'un objet.
     * @return this.status Status
     */
    public Status getStatus()
    {
        return this.status;
    }

    /**
     * Liste des états possibles d'un objet.
     * @param statusIn Status
     */
    public void setStatus(Status statusIn)
    {
        this.status = statusIn;
    }

    private Collection<SandreQualityLevelImp> sandreQualityLevelImpIds = new HashSet<SandreQualityLevelImp>();

    /**
     * Niveau de qualité sandre pour les imports de données
     * @return this.sandreQualityLevelImpIds Collection<SandreQualityLevelImp>
     */
    public Collection<SandreQualityLevelImp> getSandreQualityLevelImpIds()
    {
        return this.sandreQualityLevelImpIds;
    }

    /**
     * Niveau de qualité sandre pour les imports de données
     * @param sandreQualityLevelImpIdsIn Collection<SandreQualityLevelImp>
     */
    public void setSandreQualityLevelImpIds(Collection<SandreQualityLevelImp> sandreQualityLevelImpIdsIn)
    {
        this.sandreQualityLevelImpIds = sandreQualityLevelImpIdsIn;
    }

    /**
     * Niveau de qualité sandre pour les imports de données
     * @param elementToAdd SandreQualityLevelImp
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addSandreQualityLevelImpIds(SandreQualityLevelImp elementToAdd)
    {
        return this.sandreQualityLevelImpIds.add(elementToAdd);
    }

    /**
     * Niveau de qualité sandre pour les imports de données
     * @param elementToRemove SandreQualityLevelImp
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeSandreQualityLevelImpIds(SandreQualityLevelImp elementToRemove)
    {
        return this.sandreQualityLevelImpIds.remove(elementToRemove);
    }

    private Collection<MeasuredProfile> measuredProfiles = new HashSet<MeasuredProfile>();

    /**
     * Profil mesuré envoyé à Coriolis
     * La référence des profils est QUADRIGE-DDMMYYYY-XXXX
     * Elle est générée à partir de l'identifiant, de la date de création et d'une chaine en dur.
     * @return this.measuredProfiles Collection<MeasuredProfile>
     */
    public Collection<MeasuredProfile> getMeasuredProfiles()
    {
        return this.measuredProfiles;
    }

    /**
     * Profil mesuré envoyé à Coriolis
     * La référence des profils est QUADRIGE-DDMMYYYY-XXXX
     * Elle est générée à partir de l'identifiant, de la date de création et d'une chaine en dur.
     * @param measuredProfilesIn Collection<MeasuredProfile>
     */
    public void setMeasuredProfiles(Collection<MeasuredProfile> measuredProfilesIn)
    {
        this.measuredProfiles = measuredProfilesIn;
    }

    /**
     * Profil mesuré envoyé à Coriolis
     * La référence des profils est QUADRIGE-DDMMYYYY-XXXX
     * Elle est générée à partir de l'identifiant, de la date de création et d'une chaine en dur.
     * @param elementToAdd MeasuredProfile
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addMeasuredProfiles(MeasuredProfile elementToAdd)
    {
        return this.measuredProfiles.add(elementToAdd);
    }

    /**
     * Profil mesuré envoyé à Coriolis
     * La référence des profils est QUADRIGE-DDMMYYYY-XXXX
     * Elle est générée à partir de l'identifiant, de la date de création et d'une chaine en dur.
     * @param elementToRemove MeasuredProfile
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeMeasuredProfiles(MeasuredProfile elementToRemove)
    {
        return this.measuredProfiles.remove(elementToRemove);
    }

    /**
     * Returns <code>true</code> if the argument is an QualityFlag instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof QualityFlag))
        {
            return false;
        }
        final QualityFlag that = (QualityFlag)object;
        if (this.qualFlagCd == null || that.getQualFlagCd() == null || !this.qualFlagCd.equals(that.getQualFlagCd()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.qualFlagCd == null ? 0 : this.qualFlagCd.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link QualityFlag}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link QualityFlag}.
         * @return new QualityFlagImpl()
         */
        public static QualityFlag newInstance()
        {
            return new QualityFlagImpl();
        }

        /**
         * Constructs a new instance of {@link QualityFlag}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param qualFlagNm String
         * @param status Status
         * @return newInstance
         */
        public static QualityFlag newInstance(String qualFlagNm, Status status)
        {
            final QualityFlag entity = new QualityFlagImpl();
            entity.setQualFlagNm(qualFlagNm);
            entity.setStatus(status);
            return entity;
        }

        /**
         * Constructs a new instance of {@link QualityFlag}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param qualFlagNm String
         * @param qualFlagDc String
         * @param updateDt Timestamp
         * @param taxonMeasurements Collection<TaxonMeasurement>
         * @param sandreQualityLevelExpIds Collection<SandreQualityLevelExp>
         * @param videoIds Collection<Video>
         * @param status Status
         * @param sandreQualityLevelImpIds Collection<SandreQualityLevelImp>
         * @param measuredProfiles Collection<MeasuredProfile>
         * @return newInstance QualityFlag
         */
        public static QualityFlag newInstance(String qualFlagNm, String qualFlagDc, Timestamp updateDt, Collection<TaxonMeasurement> taxonMeasurements, Collection<SandreQualityLevelExp> sandreQualityLevelExpIds, Collection<Video> videoIds, Status status, Collection<SandreQualityLevelImp> sandreQualityLevelImpIds, Collection<MeasuredProfile> measuredProfiles)
        {
            final QualityFlag entity = new QualityFlagImpl();
            entity.setQualFlagNm(qualFlagNm);
            entity.setQualFlagDc(qualFlagDc);
            entity.setUpdateDt(updateDt);
            entity.setTaxonMeasurements(taxonMeasurements);
            entity.setSandreQualityLevelExpIds(sandreQualityLevelExpIds);
            entity.setVideoIds(videoIds);
            entity.setStatus(status);
            entity.setSandreQualityLevelImpIds(sandreQualityLevelImpIds);
            entity.setMeasuredProfiles(measuredProfiles);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(QualityFlag o)
    {
        int cmp = 0;
        if (this.getQualFlagCd() != null)
        {
            cmp = this.getQualFlagCd().compareTo(o.getQualFlagCd());
        }
        else
        {
            if (this.getQualFlagNm() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getQualFlagNm().compareTo(o.getQualFlagNm()));
            }
            if (this.getQualFlagDc() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getQualFlagDc().compareTo(o.getQualFlagDc()));
            }
            if (this.getUpdateDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDt().compareTo(o.getUpdateDt()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// QualityFlag.java merge-point
}